﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace TileViewWithExpander
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
		}

		private void myTileView_PreviewTileStateChanged(object sender, Telerik.Windows.Controls.PreviewTileStateChangedEventArgs e)
		{
			if ((e.OriginalSource as RadTileViewItem).TileState == TileViewItemState.Maximized)
			{
				this.expandButton.Visibility = System.Windows.Visibility.Visible;
			}
			else if (this.myTileView.MaximizedItem == null)
			{
				this.expandButton.Visibility = System.Windows.Visibility.Collapsed;
			}
		}

		private void expandButton_Collapsed(object sender, RoutedEventArgs e)
		{
			Storyboard sb = new Storyboard();

			DoubleAnimation da = new DoubleAnimation();
			da.From = this.myTileView.MinimizedColumnWidth;
			da.To = 0;
			da.Duration = new Duration(new TimeSpan(0, 0, 0, 0, 300));

			Storyboard.SetTarget(da, this.myTileView);
			Storyboard.SetTargetProperty(da, new PropertyPath("MinimizedColumnWidth"));

			sb.Children.Add(da);
			sb.Begin();
		}

		private void expandButton_Expanded(object sender, RoutedEventArgs e)
		{
			if (myTileView != null)
			{
				Storyboard sb = new Storyboard();

				DoubleAnimation da = new DoubleAnimation();
				da.From = this.myTileView.MinimizedColumnWidth;
				da.To = 250;
				da.Duration = new Duration(new TimeSpan(0, 0, 0, 0, 300));

				Storyboard.SetTarget(da, this.myTileView);
				Storyboard.SetTargetProperty(da, new PropertyPath("MinimizedColumnWidth"));

				sb.Children.Add(da);
				sb.Begin();
			}
		}
	}
}
